#include <AccelStepper.h>

AccelStepper stepper1(1, 2, 3);//mode, PUL+, DIR+
AccelStepper stepper2(1, 4, 5);
AccelStepper stepper3(1, 6, 7);
AccelStepper stepper4(1, 8, 9);

int maxSpeed=2000;
int acceleration=1400;

unsigned long moveTo1=10000;
unsigned long moveTo2=10000;
unsigned long moveTo3=10000;
unsigned long moveTo4=10000;

int baudRate=9600;

bool sendOnce=false;


void setup(){
  
//init serial  
  Serial.begin(baudRate);
  
//init Stepper
   stepper1.setMaxSpeed(maxSpeed);
   stepper1.setAcceleration(acceleration);
   stepper1.moveTo(moveTo1);
   
   stepper2.setMaxSpeed(maxSpeed);
   stepper2.setAcceleration(acceleration);
   stepper2.moveTo(moveTo2);
   
   stepper3.setMaxSpeed(maxSpeed);
   stepper3.setAcceleration(acceleration);
   stepper3.moveTo(moveTo3);
   
   stepper4.setMaxSpeed(maxSpeed);
   stepper4.setAcceleration(acceleration);
   stepper4.moveTo(moveTo4);

}

void loop() {

  
//Listen Serial
    while (Serial.available() > 0) {
    //  Serial.println("Serial in!"+Serial.read());
    // look for the next valid integer in the incoming serial stream:
    unsigned long receive1 = Serial.parseInt(); 
    // do it again:
    unsigned long receive2 = Serial.parseInt(); 
    // do it again:
    unsigned long receive3 = Serial.parseInt(); 
    // do it again:
    unsigned long receive4 = Serial.parseInt();
    
    

    char lastC=Serial.read();
    // look for normal
    if (lastC=='n') 
    {
      moveTo1 = receive1;
      moveTo2 = receive2;
      moveTo3 = receive3;
      moveTo4 = receive4;
      //reset=false;
      moveToMotors();
      sendOnce=false;
    }
  }
  
  

    normalMode();
    //LISTEN WHEN IF TASK IS OVER
    if (stepper1.distanceToGo() == 0 && stepper2.distanceToGo() == 0 && stepper3.distanceToGo() == 0 && stepper4.distanceToGo() == 0)
    {
      if(sendOnce==false){
      Serial.println("donepos");
    sendOnce=true;  
    }  
  }


}

void moveToMotors()
{

    stepper1.moveTo(moveTo1);
    
    stepper2.moveTo(moveTo2);
    
    stepper3.moveTo(moveTo3);
    
    stepper4.moveTo(moveTo4);
    
    //send feedback to confirm data was received
    Serial.print(moveTo1);
    Serial.print("1");
    Serial.print(moveTo2);
    Serial.print("2");
    Serial.print(moveTo3);
    Serial.println("3");
    Serial.print(moveTo4);
    Serial.println("4");

}

void normalMode()
{

    stepper1.run();
    stepper2.run();
    stepper3.run();
    stepper4.run();
    
    
}

