#pragma once
#include "ofMain.h"


#define INACTIVE 0
#define ROTATING 1
#define FINISHEDROTATION 2

#define CLOCKWISE 0
#define ANTICLOCKWISE 1

struct motor{
int motorState;
int stepPerRevolution;
string motorName;
long target;
};

class ofxStepperMotors : public ofBaseApp{
public:
    ofxStepperMotors();
	//virtual ~ofxStepperMotors();

void connectArduino(string port,int baudRate);
void setupMotors(string name,int stepPerRevolution);

void step(int steps,int  motorN,bool direction);
void step(int steps,string motorName,bool direction);
void stepWithAngle(int angle,int motorN, bool direction);
void stepWithAngle(int angle,string motorName, bool direction);
void send(bool overRideCommand);

void update();

int getMotorState(int motorN);
int getMotorState(string motorName);

int getAngle(int motorN);
int getAngle(string motorName);
int getStep(int motorN);
int getStep(string motorName);

private:
        vector<motor>motors;
        void sendSerial(bool overRide);
		string  ofxGetSerialString(ofSerial &serial, char until);
        string ofxTrimStringRight(string str);
        string ofxTrimStringLeft(string str);
        string ofxTrimString(string str);
        ofSerial serial;
};
